#
# spec file for package ocaml-lablgtk2
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Version:        2.18.3
Release:        4.2
%{ocaml_preserve_bytecode}
%global __ocaml_requires_opts -i GtkSourceView_types -i GtkSourceView2_types
Name:           ocaml-lablgtk2
Source0:        lablgtk-%{version}.tar.gz
BuildRequires:  gtk2-devel
BuildRequires:  gtksourceview18-devel
%if %suse_version >= 1210
BuildRequires:  gtksourceview2-devel
%endif
BuildRequires:  gtkspell-devel
BuildRequires:  libglade2-devel
BuildRequires:  libgnomecanvas-devel
BuildRequires:  libgnomeui-devel
BuildRequires:  librsvg-devel
BuildRequires:  ocaml
BuildRequires:  ocaml-camlp4-devel
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-lablgl-devel
BuildRequires:  ocaml-rpm-macros >= 4.02.1
BuildRequires:  xorg-x11
BuildRequires:  zlib-devel
Requires:       ocaml
Provides:       lablgtk2 = %{version}
Obsoletes:      lablgtk2 < %{version}
Provides:       ocaml-lablgtk = %{version}
Obsoletes:      ocaml-lablgtk < %{version}
Url:            http://lablgtk.forge.ocamlcore.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
# ocaml autodep start for pkg: ocaml-lablgtk2
# hardcoded rpm dependency for pre 12.1 to compensate for lack of ocaml() provides/requires
%if 0%{?suse_version} < 1210
Requires:       ocaml-runtime
%endif
# ocaml autodep end for pkg: ocaml-lablgtk2
Summary:        An Objective Caml Interface to gtk2+
License:        LGPL-2.1+
Group:          Development/Libraries/Other

%description
LablGTK2 uses the rich type system of Objective Caml 3 to provide a
strongly typed, yet very comfortable, object-oriented interface to
GTK2+. Objective Caml threads are supported, including for the top
level, which allows the interactive use of the library.



Authors:
--------
    Jacques Garrigue <garrigue@kurims.kyoto-u.ac.jp>
    Benjamin Monate  <monate@lix.polytechnique.fr>
    Olivier Andrieu  <oandrieu@nerim.net>
    Jun Furuse       <Jun.Furuse@inria.fr>
    Hubert Fauque    <hubert.fauque@wanadoo.fr>
    Koji Kagawa      <kagawa@eng.kagawa-u.ac.jp>

%package devel
# ocaml autodep start for pkg: ocaml-lablgtk2-devel
# hardcoded rpm dependency for pre 12.1 to compensate for lack of ocaml() provides/requires
%if 0%{?suse_version} < 1210
Requires:       ocaml-runtime
%endif
# ocaml autodep end for pkg: ocaml-lablgtk2-devel
Summary:        An Objective Caml interface to gtk2+
Group:          Development/Libraries/Other
Provides:       lablgtk2-devel = %{version}
Obsoletes:      lablgtk2-devel < %{version}
Provides:       ocaml-lablgtk-devel = %{version}
Obsoletes:      ocaml-lablgtk-devel < %{version}
Provides:       lablgtk2:/usr/lib/ocaml/lablgtk2/glib.cmi
Requires:       %{name} = %{version}
Requires:       gtk2-devel
Requires:       gtksourceview18-devel
%if %suse_version >= 1210
Requires:       gtksourceview2-devel
%endif
Requires:       libgnomecanvas-devel

%description devel
LablGTK2 uses the rich type system of Objective Caml 3 to provide a
strongly typed, yet very comfortable, object-oriented interface to
GTK2+. Objective Caml threads are supported, including for the top
level, which allows for interactive use of the library.



Authors:
--------
    Jacques Garrigue <garrigue@kurims.kyoto-u.ac.jp>
    Benjamin Monate  <monate@lix.polytechnique.fr>
    Olivier Andrieu  <oandrieu@nerim.net>
    Jun Furuse       <Jun.Furuse@inria.fr>
    Hubert Fauque    <hubert.fauque@wanadoo.fr>
    Koji Kagawa      <kagawa@eng.kagawa-u.ac.jp>

%prep
%setup -q -n lablgtk-%{version}
find -name ".cvsignore" -print -delete
# fix README file executable permissions
chmod a-x README

%build
export CFLAGS="$RPM_OPT_FLAGS"
make configure 
%configure --with-gnomecanvas
make world
%if %{ocaml_native_compiler}
make opt
pushd src
make lablgtk.cmxa
make lablrsvg.cmxa
make gtkInit.cmx
popd
%endif

%install
%makeinstall
# Remove ld.conf (part of main OCaml dist).
rm $RPM_BUILD_ROOT%{_libdir}/ocaml/ld.conf
#
mkdir -vp %{buildroot}/etc/ld.so.conf.d/
tee %{buildroot}/etc/ld.so.conf.d/%{name}.conf <<_EOF_
%{_libdir}/ocaml/lablgtk2
_EOF_
#

%post   -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)
%doc CHANGES COPYING README examples
/etc/ld.so.conf.d/*.conf
%{_bindir}/*
%if %{ocaml_native_compiler}
%{_libdir}/ocaml/*/*.cmxs
%endif
%{_libdir}/ocaml/*/*.so

%files devel
%defattr(-, root, root)
%doc examples
%dir %{_libdir}/ocaml
%dir %{_libdir}/ocaml/*
%{_libdir}/ocaml/*/*.a
%if %{ocaml_native_compiler}
%{_libdir}/ocaml/*/*.cmx
%{_libdir}/ocaml/*/*.cmxa
%{_libdir}/ocaml/*/*.o
%endif
%{_libdir}/ocaml/*/*.cma
%{_libdir}/ocaml/*/*.cmi
%{_libdir}/ocaml/*/*.cmo
%{_libdir}/ocaml/*/*.h
%{_libdir}/ocaml/*/*.ml
%{_libdir}/ocaml/*/*.mli
%{_libdir}/ocaml/*/META
%{_libdir}/ocaml/*/propcc
%{_libdir}/ocaml/*/varcc

%changelog
* Tue Nov 10 2015 ohering@suse.de
- Add hardcoded Provides for pre 12.1 repos
* Tue Jun 23 2015 ohering@suse.de
- update to 2.18.3
* Thu Oct 23 2014 ohering@suse.de
- BuildRequire ocaml-rpm-macros
* Sat Sep 27 2014 peter.trommler@ohm-hochschule.de
- update to 2.18.2
  * Revert old commit which broke notify signals
  * Quote $(FLINSTALLDIR) in Makefile (cf PR#1342)
  * Update applications/browser for 4.02
  * Make Float_val an alias for Double_val, since it was used
    wrongly anyway (Felix Ruess)
  * Make GObj.misc_ops#add_accelerator polymorphic in the widget of
    the signal (Erkki Seppala)
  * Use properties in GtkAdjustment, rather than direct accessors
  * fix GtkTree.IconView.get_path_at_pos (Thomas Leonard)
  * add gtksourceview2 to windows binaries
  * prepare release
  * update applications for 4.01
  * various fixes in windows port
  * add some GTK enumerations and update stock icon list
  * add properties GtkTreeView.enable_{tree,grid}_lines
  * add properties GtkEntry.{primary,secondary}_icon_{stock,name,pixbuf},
    see examples/entry2.ml for usage
  * add tags in GtkMovementStep
  * fix compatibility with ocaml 4.01 (?lab for non-optional arguments)
  * add handling of new modifiers
  * detect findlib during configuration
  * support DESTDIR with findlib-install
  * indicate that only old-install supports DESTDIR
  * have old-install copy the META file too
  * cleanup the two phases of findlib-install
  * update Windows port, compiles fine on mingw with
    ./configure --disable-gtktest
  * lablgtk2 script does not load extra libraries by default
    (use flag -all to load all extensions)
  * generate correct lablgtk2 script for findlib.
  * add old-uninstall target.
  * support threaded toplevel with Quartz backend, using gtkThTop.ml
    (runs the toplevel loop in another thread)
  * remove GtkThInit from META (not portable)
  * avoid busy waiting by using g_main_context_set_poll_func to
    make polling non-blocking.
    busy waiting is still needed for VM threads, and can be activated
    by setting the environment variable LABLGTK_BUSY_WAIT.
  * update applications/browser for OCaml 4.00
  * update applications/camlirc to use GText instead of GBroken.text
  * improvements to GtkSourceView2.
  * add cast and assignation functions to GText.nocopy_iter.
  * add Gtk 2.10 missing key modifiers.
  * can still install using old-install.
  * add a high-level API to create keyboard shortcuts.
  * add several #as_foo methods: entry, notebook, range
  * new signals for notebook: select_page, reorder_tab,
    change_current_page, move_focus_out, page_{added,removed,reordered}
  * add gtk_container_child_{set,get}_property
  * add gtk_notebook_{set,get}_tab_reorderable
  * add gtk_signal_new which can be used to create custom keyboard shortcuts
  * add g_signal_list and g_signal_query
  * add functions to connect to notify::foo signals which indicate when an
    object property changes
  * add foo#connect#notify_bar methods to add callbacks on changes of
    the "bar" property of the object "foo".
  * use findlib to install (see README for the list of installed packages)
  * merge GtkSourceView2 additions by Pierre-Marie Pedrot
  * add Make_Val_option to wrappers.h
  * add gtk_accelerator_name/get_label (for Pierre Boutillier)
  * add gtk_accel_map_foreach/change_entry (ibid)
  * add gdk_window_clear_area (for DDR)
  * make gtk_tree_view_get_visible_range version dependent (Thomas Ripoche)
* Mon Jun  3 2013 ohering@suse.de
- Recompress with xz
* Wed Jan 16 2013 ohering@suse.de
- disable also /usr/lib/rpm/find-debuginfo.sh
* Mon Jan 14 2013 ohering@suse.de
- disable strip, it destroys bytecode binaries
* Wed Jan  2 2013 ohering@suse.de
- update specfile to handle disabled do_opt variable
* Mon Nov 12 2012 ohering@suse.de
- BR gtksourceview2-devel in 12.1 and later
* Mon Nov 12 2012 ohering@suse.de
- remove gtksourceview-devel from BuilrRequires, configure does
  not check for version 3
- require gtksourceview18-devel in devel subpackage
* Sat Nov 10 2012 peter.trommler@ohm-hochschule.de
- BR gtksourceview2-devel to provide lablgtksourceview2
* Mon Sep 17 2012 ohering@suse.de
- rename package lablgtk2 to ocaml-lablgtk2
* Fri Jun 17 2011 ampsaltis@gmail.com
- Use ocaml-camlp4-devel instead of camlp4 in BuildRequires
* Wed May 25 2011 idonmez@novell.com
- Ignore GtkSourceView_types and GtkSourceView2_types symbols
* Mon May  2 2011 jslaby@suse.de
- install also .so dlls
- require some gtk libs in the devel package to be able to
  build against the libs
* Wed Nov 10 2010 mhopf@novell.com
- Add additional build dependencies (bnc #413806)
* Thu Oct  7 2010 aj@suse.de
- Update to 2.14.2:
  * Fix incompatibility with ocaml 3.12.
  * Fixes for newer gtk/glib versions.
- Rename rpmlintrc to make name unique.
* Tue Dec  8 2009 mhopf@novell.com
- Configure with --with-gnomecanvas (bnc #560703)
* Wed Feb 25 2009 seife@suse.de
- update to version 2.12.0
  - please see the changelog for details
* Thu Feb 19 2009 radomir.cernoch@gmail.com
- 'make' changed to 'make world' to build additional libraries
- 'configure' changed to '%%configure'
* Mon Apr 21 2008 seife@suse.de
- update to version 2.10.1
  - fix wrong type in GContainer.mli (could not compile with 3.10.2)
  - revert to setting LC_NUMERIC to C (ocaml still uses strtod)
  - Fix Val_GType/GType_val (use Val_addr/Addr_val)
  - add ui_manager#as_ui_manager
  - Fix examples.
* Tue Jan 29 2008 seife@suse.de
- update to version 2.10.0
  - uses features of newer Gtk versions
  - some small bugfixes
* Wed Nov  7 2007 ro@suse.de
- added rpmlintrc
* Fri Jun 15 2007 ro@suse.de
- added rsvg bindings
- handle ppc64 like s390 (no ocamlopt)
* Tue Jun  5 2007 ro@suse.de
- added ocamlp4 to buildreq
- silence a compiler warning
* Thu May 24 2007 ro@suse.de
- branch off devel package
* Wed Sep 20 2006 seife@suse.de
- initial submission (cloned specfile from lablgtk)
